;*******************************************************************************
; ZX81 1K auto start loaded by Johan "Dr Beep" Koelman

; in LOWRES more sysvar are used, but in this way the
; shortest code over sysvar to start machinecode.
; This saves 11 bytes of BASIC
; DO NOT CHANGE AFTER BASIC+3 (=DFILE)

; Adapted by Paul Daniels to set DFILE at 0x4300
;*******************************************************************************

; 12 bytes from #4000 to #400B free reuseable for own code

BASIC	ld h,DFILE / 256		; highbyte of dfile
	jr INIT1
	.DB 236				; BASIC over DFILE data
	.DB 212,28			; GOTO USR 0
	.DB 126,143,0,18		; shortest FP notation of $4009
ELINE	.DW VARAREA + 1
CHADD	.DW VARAREA
	.DB 0,0,0,0,0,0			; ? not useable
BERG	.DB 0				; ? before loading
MEM	.DB 0,0				; x OVERWRITTEN ON LOAD
INIT1	ld l, DFILE # 256		; low byte of dfile
	jr INIT2
LASTK	.DB 255,255,255
MARGIN	.DB 55
NXTLIN	.DW BASIC			; BASIC-line over sysvar
					; FLAGX	equ INIT2+2
INIT2	ld (BASIC+3),hl			; repair dfile pointer
	ld l,VARAREA # 256		; end of screen lowbyte
	.DB 0				; x used by ZX81
	.DB 0				; x used by ZX81
	ld h,VARAREA / 256		; end of screen highbyte
FRAMES	.DB $37				; after loading LD (HL),N
	.DB $e9				; set JP (HL) as end of screenmarker
	or a
	ex af,af'
	jp GAMECODE			; YOUR GAMECODE, can be everywhere
DFLAG	.DB 64
GAMECODE
; DO NOT CHANGE SYSVAR ABOVE!
